import { ITelegramResponse, Telegram } from './types';
export declare class TelegramAPI implements Telegram.Bot {
    readonly botId: string;
    constructor(botId: string);
    addStickerToSet(params: Telegram.Params.AddStickerToSet): ITelegramResponse<true>;
    answerCallbackQuery(params: Telegram.Params.AnswerCallbackQuery): ITelegramResponse<true>;
    answerInlineQuery(params: Telegram.Params.AnswerInlineQuery): ITelegramResponse<true>;
    answerPreCheckoutQuery(params: Telegram.Params.AnswerPreCheckoutQuery): ITelegramResponse<true>;
    answerShippingQuery(params: Telegram.Params.AnswerShippingQuery): ITelegramResponse<true>;
    answerWebAppQuery(params: Telegram.Params.AnswerWebAppQuery): ITelegramResponse<Telegram.SentWebAppMessage>;
    approveChatJoinRequest(params: Telegram.Params.ApproveChatJoinRequest): ITelegramResponse<true>;
    banChatMember(params: Telegram.Params.BanChatMember): ITelegramResponse<true>;
    banChatSenderChat(params: Telegram.Params.BanChatSenderChat): ITelegramResponse<true>;
    close(): ITelegramResponse<true>;
    closeForumTopic(params: Telegram.Params.CloseForumTopic): ITelegramResponse<true>;
    closeGeneralForumTopic(params: Telegram.Params.CloseGeneralForumTopic): ITelegramResponse<true>;
    copyMessage(params: Telegram.Params.CopyMessage): ITelegramResponse<Telegram.MessageId>;
    copyMessages(params: Telegram.Params.CopyMessages): ITelegramResponse<ReadonlyArray<Telegram.MessageId>>;
    createChatInviteLink(params: Telegram.Params.CreateChatInviteLink): ITelegramResponse<Telegram.ChatInviteLink>;
    createForumTopic(params: Telegram.Params.CreateForumTopic): ITelegramResponse<Telegram.ForumTopic>;
    createInvoiceLink(params: Telegram.Params.CreateInvoiceLink): ITelegramResponse<string>;
    createNewStickerSet(params: Telegram.Params.CreateNewStickerSet): ITelegramResponse<true>;
    declineChatJoinRequest(params: Telegram.Params.DeclineChatJoinRequest): ITelegramResponse<true>;
    deleteChatPhoto(params: Telegram.Params.DeleteChatPhoto): ITelegramResponse<true>;
    deleteChatStickerSet(params: Telegram.Params.DeleteChatStickerSet): ITelegramResponse<true>;
    deleteForumTopic(params: Telegram.Params.DeleteForumTopic): ITelegramResponse<true>;
    deleteMessage(params: Telegram.Params.DeleteMessage): ITelegramResponse<true>;
    deleteMessages(params: Telegram.Params.DeleteMessages): ITelegramResponse<true>;
    deleteMyCommands(params: Telegram.Params.DeleteMyCommands): ITelegramResponse<true>;
    deleteStickerFromSet(params: Telegram.Params.DeleteStickerFromSet): ITelegramResponse<true>;
    replaceStickerInSet(params: Telegram.Params.ReplaceStickerInSet): ITelegramResponse<true>;
    deleteStickerSet(params: Telegram.Params.DeleteStickerSet): ITelegramResponse<true>;
    deleteWebhook(params: Telegram.Params.DeleteWebhook): ITelegramResponse<true>;
    editChatInviteLink(params: Telegram.Params.EditChatInviteLink): ITelegramResponse<Telegram.ChatInviteLink>;
    editForumTopic(params: Telegram.Params.EditForumTopic): ITelegramResponse<true>;
    editGeneralForumTopic(params: Telegram.Params.EditGeneralForumTopic): ITelegramResponse<true>;
    editMessageCaption(params: Telegram.Params.EditMessageCaption): ITelegramResponse<Telegram.Message | true>;
    editMessageLiveLocation(params: Telegram.Params.EditMessageLiveLocation): ITelegramResponse<Telegram.Message | true>;
    editMessageMedia(params: Telegram.Params.EditMessageMedia): ITelegramResponse<Telegram.Message | true>;
    editMessageReplyMarkup(params: Telegram.Params.EditMessageReplyMarkup): ITelegramResponse<Telegram.Message | true>;
    editMessageText(params: Telegram.Params.EditMessageText): ITelegramResponse<Telegram.Message | true>;
    exportChatInviteLink(params: Telegram.Params.ExportChatInviteLink): ITelegramResponse<string>;
    forwardMessage(params: Telegram.Params.ForwardMessage): ITelegramResponse<Telegram.Message>;
    getChat(params: Telegram.Params.GetChat): ITelegramResponse<Telegram.Chat>;
    getChatAdministrators(params: Telegram.Params.GetChatAdministrators): ITelegramResponse<readonly Telegram.ChatMember[]>;
    getChatMember(params: Telegram.Params.GetChatMember): ITelegramResponse<Telegram.ChatMember>;
    getChatMemberCount(params: Telegram.Params.GetChatMemberCount): ITelegramResponse<number>;
    getChatMenuButton(params: Telegram.Params.GetChatMenuButton): ITelegramResponse<Telegram.MenuButton>;
    getCustomEmojiStickers(params: Telegram.Params.GetCustomEmojiStickers): ITelegramResponse<readonly Telegram.Sticker[]>;
    getFile(params: Telegram.Params.GetFile): ITelegramResponse<Telegram.File>;
    getForumTopicIconStickers(): ITelegramResponse<readonly Telegram.Sticker[]>;
    getGameHighScores(params: Telegram.Params.GetGameHighScores): ITelegramResponse<readonly Telegram.GameHighScore[]>;
    getMe(): ITelegramResponse<Telegram.User>;
    getMyCommands(params: Telegram.Params.GetMyCommands): ITelegramResponse<readonly Telegram.BotCommand[]>;
    getMyDefaultAdministratorRights(params: Telegram.Params.GetMyDefaultAdministratorRights): ITelegramResponse<Telegram.ChatAdministratorRights>;
    getMyDescription(params: Telegram.Params.GetMyDescription): ITelegramResponse<Telegram.BotDescription>;
    getMyShortDescription(params: Telegram.Params.GetMyShortDescription): ITelegramResponse<Telegram.BotShortDescription>;
    getStickerSet(params: Telegram.Params.GetStickerSet): ITelegramResponse<Telegram.StickerSet>;
    getUpdates(params: Telegram.Params.GetUpdates): ITelegramResponse<readonly Telegram.Update[]>;
    getUserChatBoosts(params: Telegram.Params.GetUserChatBoosts): ITelegramResponse<Telegram.UserChatBoosts>;
    getBusinessConnection(params: Telegram.Params.GetBusinessConnection): ITelegramResponse<Telegram.BusinessConnection>;
    getUserProfilePhotos(params: Telegram.Params.GetUserProfilePhotos): ITelegramResponse<Telegram.UserProfilePhotos>;
    getWebhookInfo(): ITelegramResponse<Telegram.WebhookInfo | Readonly<{
        url: unknown;
    }>>;
    hideGeneralForumTopic(params: Telegram.Params.HideGeneralForumTopic): ITelegramResponse<true>;
    leaveChat(params: Telegram.Params.LeaveChat): ITelegramResponse<true>;
    logOut(): ITelegramResponse;
    pinChatMessage(params: Telegram.Params.PinChatMessage): ITelegramResponse<true>;
    promoteChatMember(params: Telegram.Params.PromoteChatMember): ITelegramResponse<true>;
    refundStarPayment(params: Telegram.Params.RefundStarPayment): ITelegramResponse<true>;
    reopenForumTopic(params: Telegram.Params.ReopenForumTopic): ITelegramResponse<true>;
    reopenGeneralForumTopic(params: Telegram.Params.ReopenGeneralForumTopic): ITelegramResponse<true>;
    restrictChatMember(params: Telegram.Params.RestrictChatMember): ITelegramResponse<true>;
    revokeChatInviteLink(params: Telegram.Params.RevokeChatInviteLink): ITelegramResponse<Telegram.ChatInviteLink>;
    sendAnimation(params: Telegram.Params.SendAnimation): ITelegramResponse<Telegram.Message>;
    sendAudio(params: Telegram.Params.SendAudio): ITelegramResponse<Telegram.Message>;
    sendChatAction(params: Telegram.Params.SendChatAction): ITelegramResponse<true>;
    setMessageReaction(params: Telegram.Params.SetMessageReaction): ITelegramResponse<true>;
    sendContact(params: Telegram.Params.SendContact): ITelegramResponse<Telegram.Message>;
    sendDice(params: Telegram.Params.SendDice): ITelegramResponse<Telegram.Message>;
    sendDocument(params: Telegram.Params.SendDocument): ITelegramResponse<Telegram.Message>;
    sendGame(params: Telegram.Params.SendGame): ITelegramResponse<Telegram.Message>;
    sendInvoice(params: Telegram.Params.SendInvoice): ITelegramResponse<Telegram.Message>;
    sendLocation(params: Telegram.Params.SendLocation): ITelegramResponse<Telegram.Message>;
    sendMediaGroup(params: Telegram.Params.SendMediaGroup): ITelegramResponse<readonly Telegram.Message[]>;
    sendMessage(params: Telegram.Params.SendMessage): ITelegramResponse<Telegram.Message>;
    forwardMessages(params: Telegram.Params.ForwardMessages): ITelegramResponse<ReadonlyArray<Telegram.MessageId>>;
    sendPhoto(params: Telegram.Params.SendPhoto): ITelegramResponse<Telegram.Message>;
    sendPoll(params: Telegram.Params.SendPoll): ITelegramResponse<Telegram.Message>;
    sendSticker(params: Telegram.Params.SendSticker): ITelegramResponse<Telegram.Message>;
    sendVenue(params: Telegram.Params.SendVenue): ITelegramResponse<Telegram.Message>;
    sendVideo(params: Telegram.Params.SendVideo): ITelegramResponse<Telegram.Message>;
    sendVideoNote(params: Telegram.Params.SendVideoNote): ITelegramResponse<Telegram.Message>;
    sendVoice(params: Telegram.Params.SendVoice): ITelegramResponse<Telegram.Message>;
    setChatAdministratorCustomTitle(params: Telegram.Params.SetChatAdministratorCustomTitle): ITelegramResponse<true>;
    setChatDescription(params: Telegram.Params.SetChatDescription): ITelegramResponse<true>;
    setChatMenuButton(params: Telegram.Params.SetChatMenuButton): ITelegramResponse<true>;
    setChatPermissions(params: Telegram.Params.SetChatPermissions): ITelegramResponse<true>;
    setChatPhoto(params: Telegram.Params.SetChatPhoto): ITelegramResponse<true>;
    setChatStickerSet(params: Telegram.Params.SetChatStickerSet): ITelegramResponse<true>;
    setChatTitle(params: Telegram.Params.SetChatTitle): ITelegramResponse<true>;
    setCustomEmojiStickerSetThumbnail(params: Telegram.Params.SetCustomEmojiStickerSetThumbnail): ITelegramResponse<true>;
    setGameScore(params: Telegram.Params.SetGameScore): ITelegramResponse<Telegram.Message | true>;
    setMyCommands(params: Telegram.Params.SetMyCommands): ITelegramResponse<true>;
    setMyDefaultAdministratorRights(params: Telegram.Params.SetMyDefaultAdministratorRights): ITelegramResponse<true>;
    setMyName(params: Telegram.Params.SetMyName): ITelegramResponse<true>;
    getMyName(params: Telegram.Params.GetMyName): ITelegramResponse<Telegram.BotName>;
    setMyDescription(params: Telegram.Params.SetMyDescription): ITelegramResponse<true>;
    setMyShortDescription(params: Telegram.Params.SetMyShortDescription): ITelegramResponse<true>;
    setPassportDataErrors(params: Telegram.Params.SetPassportDataErrors): ITelegramResponse<true>;
    setStickerEmojiList(params: Telegram.Params.SetStickerEmojiList): ITelegramResponse<true>;
    setStickerKeywords(params: Telegram.Params.SetStickerKeywords): ITelegramResponse<true>;
    setStickerMaskPosition(params: Telegram.Params.SetStickerMaskPosition): ITelegramResponse<true>;
    setStickerPositionInSet(params: Telegram.Params.SetStickerPositionInSet): ITelegramResponse<true>;
    setStickerSetThumbnail(params: Telegram.Params.SetStickerSetThumbnail): ITelegramResponse<true>;
    setStickerSetTitle(params: Telegram.Params.SetStickerSetTitle): ITelegramResponse<true>;
    setWebhook(params: Telegram.Params.SetWebhook): ITelegramResponse<true>;
    stopMessageLiveLocation(params: Telegram.Params.StopMessageLiveLocation): ITelegramResponse<Telegram.Message | true>;
    stopPoll(params: Telegram.Params.StopPoll): ITelegramResponse<Telegram.Poll>;
    unbanChatMember(params: Telegram.Params.UnbanChatMember): ITelegramResponse<true>;
    unbanChatSenderChat(params: Telegram.Params.UnbanChatSenderChat): ITelegramResponse<true>;
    unhideGeneralForumTopic(params: Telegram.Params.UnhideGeneralForumTopic): ITelegramResponse<true>;
    unpinAllGeneralForumTopicMessages(params: Telegram.Params.UnpinAllGeneralForumTopicMessages): ITelegramResponse<true>;
    unpinAllChatMessages(params: Telegram.Params.UnpinAllChatMessages): ITelegramResponse<true>;
    unpinAllForumTopicMessages(params: Telegram.Params.UnpinAllForumTopicMessages): ITelegramResponse<true>;
    unpinChatMessage(params: Telegram.Params.UnpinChatMessage): ITelegramResponse<true>;
    uploadStickerFile(params: Telegram.Params.UploadStickerFile): ITelegramResponse<Telegram.File>;
    private _call;
    private _sendForm;
}
