"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TelegramAPI = void 0;
const https = require("https");
const FormData = require("form-data");
class TelegramAPI {
    constructor(botId) {
        this.botId = botId;
    }
    addStickerToSet(params) {
        return this._call('addStickerToSet', params);
    }
    answerCallbackQuery(params) {
        return this._call('answerCallbackQuery', params);
    }
    answerInlineQuery(params) {
        return this._call('answerInlineQuery', params);
    }
    answerPreCheckoutQuery(params) {
        return this._call('answerPreCheckoutQuery', params);
    }
    answerShippingQuery(params) {
        return this._call('answerShippingQuery', params);
    }
    answerWebAppQuery(params) {
        return this._call('answerWebAppQuery', params);
    }
    approveChatJoinRequest(params) {
        return this._call('approveChatJoinRequest', params);
    }
    banChatMember(params) {
        return this._call('banChatMember', params);
    }
    banChatSenderChat(params) {
        return this._call('banChatSenderChat', params);
    }
    close() {
        return this._call('close');
    }
    closeForumTopic(params) {
        return this._call('closeForumTopic', params);
    }
    closeGeneralForumTopic(params) {
        return this._call('closeGeneralForumTopic', params);
    }
    copyMessage(params) {
        return this._call('copyMessage', params);
    }
    copyMessages(params) {
        return this._call('copyMessages', params);
    }
    createChatInviteLink(params) {
        return this._call('createChatInviteLink', params);
    }
    createForumTopic(params) {
        return this._call('createForumTopic', params);
    }
    createInvoiceLink(params) {
        return this._call('createInvoiceLink', params);
    }
    createNewStickerSet(params) {
        return this._call('createNewStickerSet', params);
    }
    declineChatJoinRequest(params) {
        return this._call('declineChatJoinRequest', params);
    }
    deleteChatPhoto(params) {
        return this._call('deleteChatPhoto', params);
    }
    deleteChatStickerSet(params) {
        return this._call('deleteChatStickerSet', params);
    }
    deleteForumTopic(params) {
        return this._call('deleteForumTopic', params);
    }
    deleteMessage(params) {
        return this._call('deleteMessage', params);
    }
    deleteMessages(params) {
        return this._call('deleteMessages', params);
    }
    deleteMyCommands(params) {
        return this._call('deleteMyCommands', params);
    }
    deleteStickerFromSet(params) {
        return this._call('deleteStickerFromSet', params);
    }
    replaceStickerInSet(params) {
        return this._call('replaceStickerInSet', params);
    }
    deleteStickerSet(params) {
        return this._call('deleteStickerSet', params);
    }
    deleteWebhook(params) {
        return this._call('deleteWebhook', params);
    }
    editChatInviteLink(params) {
        return this._call('editChatInviteLink', params);
    }
    editForumTopic(params) {
        return this._call('editForumTopic', params);
    }
    editGeneralForumTopic(params) {
        return this._call('editGeneralForumTopic', params);
    }
    editMessageCaption(params) {
        return this._call('editMessageCaption', params);
    }
    editMessageLiveLocation(params) {
        return this._call('editMessageLiveLocation', params);
    }
    editMessageMedia(params) {
        return this._call('editMessageMedia', params);
    }
    editMessageReplyMarkup(params) {
        return this._call('editMessageReplyMarkup', params);
    }
    editMessageText(params) {
        return this._call('editMessageText', params);
    }
    exportChatInviteLink(params) {
        return this._call('exportChatInviteLink', params);
    }
    forwardMessage(params) {
        return this._call('forwardMessage', params);
    }
    getChat(params) {
        return this._call('getChat', params);
    }
    getChatAdministrators(params) {
        return this._call('getChatAdministrators', params);
    }
    getChatMember(params) {
        return this._call('getChatMember', params);
    }
    getChatMemberCount(params) {
        return this._call('getChatMemberCount', params);
    }
    getChatMenuButton(params) {
        return this._call('getChatMenuButton', params);
    }
    getCustomEmojiStickers(params) {
        return this._call('getCustomEmojiStickers', params);
    }
    getFile(params) {
        return this._call('getFile', params);
    }
    getForumTopicIconStickers() {
        return this._call('getForumTopicIconStickers');
    }
    getGameHighScores(params) {
        return this._call('getGameHighScores', params);
    }
    getMe() {
        return this._call('getMe');
    }
    getMyCommands(params) {
        return this._call('getMyCommands', params);
    }
    getMyDefaultAdministratorRights(params) {
        return this._call('getMyDefaultAdministratorRights', params);
    }
    getMyDescription(params) {
        return this._call('getMyDescription', params);
    }
    getMyShortDescription(params) {
        return this._call('getMyShortDescription', params);
    }
    getStickerSet(params) {
        return this._call('getStickerSet', params);
    }
    getUpdates(params) {
        return this._call('getUpdates', params);
    }
    getUserChatBoosts(params) {
        return this._call('getUserChatBoosts', params);
    }
    getBusinessConnection(params) {
        return this._call('getBusinessConnection', params);
    }
    getUserProfilePhotos(params) {
        return this._call('getUserProfilePhotos', params);
    }
    getWebhookInfo() {
        return this._call('getWebhookInfo');
    }
    hideGeneralForumTopic(params) {
        return this._call('hideGeneralForumTopic', params);
    }
    leaveChat(params) {
        return this._call('leaveChat', params);
    }
    logOut() {
        return this._call('logOut');
    }
    pinChatMessage(params) {
        return this._call('pinChatMessage', params);
    }
    promoteChatMember(params) {
        return this._call('promoteChatMember', params);
    }
    refundStarPayment(params) {
        return this._call('refundStarPayment', params);
    }
    reopenForumTopic(params) {
        return this._call('reopenForumTopic', params);
    }
    reopenGeneralForumTopic(params) {
        return this._call('reopenGeneralForumTopic', params);
    }
    restrictChatMember(params) {
        return this._call('restrictChatMember', params);
    }
    revokeChatInviteLink(params) {
        return this._call('revokeChatInviteLink', params);
    }
    sendAnimation(params) {
        if (typeof params.animation === 'object') {
            return this._sendForm('sendAnimation', params, 'animation');
        }
        return this._call('sendAnimation', params);
    }
    sendAudio(params) {
        if (typeof params.audio === 'object') {
            return this._sendForm('sendAudio', params, 'audio');
        }
        return this._call('sendAudio', params);
    }
    sendChatAction(params) {
        return this._call('sendChatAction', params);
    }
    setMessageReaction(params) {
        return this._call('setMessageReaction', params);
    }
    sendContact(params) {
        return this._call('sendContact', params);
    }
    sendDice(params) {
        return this._call('sendDice', params);
    }
    sendDocument(params) {
        if (typeof params.document === 'object') {
            return this._sendForm('sendDocument', params, 'document');
        }
        return this._call('sendDocument', params);
    }
    sendGame(params) {
        return this._call('sendGame', params);
    }
    sendInvoice(params) {
        return this._call('sendInvoice', params);
    }
    sendLocation(params) {
        return this._call('sendLocation', params);
    }
    sendMediaGroup(params) {
        return this._call('sendMediaGroup', params);
    }
    sendMessage(params) {
        return this._call('sendMessage', params);
    }
    forwardMessages(params) {
        return this._call('forwardMessages', params);
    }
    sendPhoto(params) {
        if (typeof params.photo === 'object') {
            return this._sendForm('sendPhoto', params, 'photo');
        }
        return this._call('sendPhoto', params);
    }
    sendPoll(params) {
        return this._call('sendPoll', params);
    }
    sendSticker(params) {
        return this._call('sendSticker', params);
    }
    sendVenue(params) {
        return this._call('sendVenue', params);
    }
    sendVideo(params) {
        if (typeof params.video === 'object') {
            return this._sendForm('sendVideo', params, 'video');
        }
        return this._call('sendVideo', params);
    }
    sendVideoNote(params) {
        if (typeof params.video_note === 'object') {
            return this._sendForm('sendVideoNote', params, 'video_note');
        }
        return this._call('sendVideoNote', params);
    }
    sendVoice(params) {
        if (typeof params.voice === 'object') {
            return this._sendForm('sendVoice', params, 'voice');
        }
        return this._call('sendVoice', params);
    }
    setChatAdministratorCustomTitle(params) {
        return this._call('setChatAdministratorCustomTitle', params);
    }
    setChatDescription(params) {
        return this._call('setChatDescription', params);
    }
    setChatMenuButton(params) {
        return this._call('setChatMenuButton', params);
    }
    setChatPermissions(params) {
        return this._call('setChatPermissions', params);
    }
    setChatPhoto(params) {
        if (typeof params.photo === 'object') {
            return this._sendForm('setChatPhoto', params, 'photo');
        }
        return this._call('setChatPhoto', params);
    }
    setChatStickerSet(params) {
        return this._call('setChatStickerSet', params);
    }
    setChatTitle(params) {
        return this._call('setChatTitle', params);
    }
    setCustomEmojiStickerSetThumbnail(params) {
        return this._call('setCustomEmojiStickerSetThumbnail', params);
    }
    setGameScore(params) {
        return this._call('setGameScore', params);
    }
    setMyCommands(params) {
        return this._call('setMyCommands', params);
    }
    setMyDefaultAdministratorRights(params) {
        return this._call('setMyDefaultAdministratorRights', params);
    }
    setMyName(params) {
        return this._call('setMyName', params);
    }
    getMyName(params) {
        return this._call('getMyName', params);
    }
    setMyDescription(params) {
        return this._call('setMyDescription', params);
    }
    setMyShortDescription(params) {
        return this._call('setMyShortDescription', params);
    }
    setPassportDataErrors(params) {
        return this._call('setPassportDataErrors', params);
    }
    setStickerEmojiList(params) {
        return this._call('setStickerEmojiList', params);
    }
    setStickerKeywords(params) {
        return this._call('setStickerKeywords', params);
    }
    setStickerMaskPosition(params) {
        return this._call('setStickerMaskPosition', params);
    }
    setStickerPositionInSet(params) {
        return this._call('setStickerPositionInSet', params);
    }
    setStickerSetThumbnail(params) {
        if (typeof params.thumbnail === 'object') {
            return this._sendForm('setStickerSetThumbnail', params, 'thumbnail');
        }
        return this._call('setStickerSetThumbnail', params);
    }
    setStickerSetTitle(params) {
        return this._call('setStickerSetTitle', params);
    }
    setWebhook(params) {
        if (typeof params.certificate === 'object') {
            return this._sendForm('setWebhook', params, 'certificate');
        }
        return this._call('setWebhook', params);
    }
    stopMessageLiveLocation(params) {
        return this._call('stopMessageLiveLocation', params);
    }
    stopPoll(params) {
        return this._call('stopPoll', params);
    }
    unbanChatMember(params) {
        return this._call('unbanChatMember', params);
    }
    unbanChatSenderChat(params) {
        return this._call('unbanChatSenderChat', params);
    }
    unhideGeneralForumTopic(params) {
        return this._call('unhideGeneralForumTopic', params);
    }
    unpinAllGeneralForumTopicMessages(params) {
        return this._call('unpinAllGeneralForumTopicMessages', params);
    }
    unpinAllChatMessages(params) {
        return this._call('unpinAllChatMessages', params);
    }
    unpinAllForumTopicMessages(params) {
        return this._call('unpinAllForumTopicMessages', params);
    }
    unpinChatMessage(params) {
        return this._call('unpinChatMessage', params);
    }
    uploadStickerFile(params) {
        return this._call('uploadStickerFile', params);
    }
    _call(endpoint, params) {
        const options = {
            hostname: 'api.telegram.org',
            port: 443,
            path: `/bot${this.botId}/${endpoint}`,
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
        };
        return new Promise((resolve, reject) => {
            const req = https.request(options, (res) => {
                res.setEncoding('utf8');
                let fullData = '';
                res
                    .on('data', (chunk) => {
                    fullData += chunk;
                })
                    .on('end', (a) => {
                    try {
                        let result = JSON.parse(fullData);
                        if (!!result && !result.ok) {
                            return reject({
                                ok: result.ok,
                                code: result.error_code,
                                description: result.description
                            });
                        }
                        return resolve(result);
                    }
                    catch (e) {
                        console.error(e);
                        return reject(e);
                    }
                });
            });
            req.on('error', (e) => {
                return reject(e);
            });
            try {
                if (params != null) {
                    req.write(JSON.stringify(params));
                }
            }
            catch (e) {
                return reject(e);
            }
            req.end();
        });
    }
    _sendForm(endpoint, params, fileField) {
        var _a;
        if (params == null) {
            throw new Error('Unexpected error: params must exist');
        }
        const form = new FormData();
        for (const [key, value] of Object.entries(params)) {
            if (key === fileField) {
                const inputFile = value;
                form.append(key, inputFile.file, {
                    filename: (_a = inputFile.name) !== null && _a !== void 0 ? _a : 'victory',
                });
                continue;
            }
            if (typeof value === 'object' || Array.isArray(value)) {
                form.append(key, JSON.stringify(value));
                continue;
            }
            form.append(key, value);
        }
        const options = {
            hostname: 'api.telegram.org',
            port: 443,
            path: `/bot${this.botId}/${endpoint}`,
            method: 'POST',
            headers: form.getHeaders(),
        };
        return new Promise((resolve, reject) => {
            const req = https.request(options, (res) => {
                res.setEncoding('utf8');
                let fullData = '';
                res
                    .on('data', (chunk) => {
                    fullData += chunk;
                })
                    .on('end', (a) => {
                    try {
                        let result = JSON.parse(fullData);
                        if (!!result && !result.ok) {
                            return reject({
                                ok: result.ok,
                                code: result.error_code,
                                description: result.description
                            });
                        }
                        return resolve(result);
                    }
                    catch (e) {
                        console.error(e);
                        return reject(e);
                    }
                });
            });
            req.on('error', (e) => {
                return reject(e);
            });
            try {
                if (params != null) {
                    req.write(JSON.stringify(params));
                }
            }
            catch (e) {
                return reject(e);
            }
            form.pipe(req);
        });
    }
}
exports.TelegramAPI = TelegramAPI;
//# sourceMappingURL=TelegramAPI.js.map